#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <time.h>

#include "../vncviewer/type.h"
#include "callbacks.h"
#include "interface.h"
#include "support.h"

extern GtkWidget *lock_window;
GtkWidget *lock_screen;



///
///  @brief マウス及び各キー操作のロックを行う関数
///
void
start_lock(void)
{
  gtk_widget_activate(lock_window);
  gtk_widget_show(lock_window);
  gdk_window_show(lock_window->window);
  gtk_window_present(GTK_WINDOW(lock_window));
  show_gtkwindow_top(lock_window);
  /* マウスポインタを以前のロックから解放 */
  gdk_keyboard_ungrab(GDK_CURRENT_TIME);
  gdk_pointer_ungrab(GDK_CURRENT_TIME);

  /* マウスポインタの捕獲 */
  gdk_keyboard_grab(lock_screen->window, FALSE, GDK_CURRENT_TIME);
  gdk_pointer_grab(lock_screen->window, FALSE, 0, gtk_widget_get_parent_window(lock_screen), NULL, GDK_CURRENT_TIME);
}


///
///  @brief ロックを解除する関数
///
void
stop_lock(void)
{
  if (GETLOCK_C) {
    SETLOCK_C(0);
    draw_string_to_mini_window(_("Connect"));

    gdk_keyboard_ungrab(GDK_CURRENT_TIME);
    gdk_pointer_ungrab(GDK_CURRENT_TIME);
    gtk_grab_remove(lock_window);

    gtk_widget_destroy(lock_window);
    lock_window = NULL;
  }
}
