////////////////////////////////////////////////////////////////////////////////
/// @file
/// @brief VNCコマンド関連のソース
///
/// 外部VNCソフトウェアを操作する際に利用されます。
///
/// Copyright (C) 2009 Alpha Systems Inc. All Rights Reserved.
/// @internal
/// @date $Date: $
/// @version $Revision: $
////////////////////////////////////////////////////////////////////////////////

#include "vncviewer.h"

/* VNCサーバ起動 */
void
StartVNCServer()
{
  char vncserver_cmd[16] = "vncserver :";
  char lockfile[32];
  if (atoi(vncdisplay) != 0) {
    // remove lock file
    sprintf(lockfile, "/tmp/.X%s-lock", vncdisplay);
    unlink(lockfile);
    sprintf(lockfile, "/tmp/.X11-unix/X%s", vncdisplay);
    unlink(lockfile);
    // start vnc server
    printf("---start vncserver---\n");
    strcat(vncserver_cmd, vncdisplay);
    printf("%s", vncserver_cmd);
    system(vncserver_cmd);
    printf("\n-----\n\n");
  }
}

/* VNCサーバ終了 */
void
CloseVNCServer()
{
  char vncserver_cmd[16] = "vncserver -kill :";
  if (atoi(vncdisplay) != 0) {
    printf("---close vncserver---\n");
    strcat(vncserver_cmd, vncdisplay);
    printf("%s", vncserver_cmd);
    system(vncserver_cmd);
    printf("\n-----\n\n");
  }
}

/* VNCサーバ接続 */
void
JoinVNC () {
  char commandvnc1[MAXBUF];
  char commandvnc2[MAXBUF];
  char commandvnc3[MAXBUF];
  char serverport[10];
  struct in_addr serverip;
  int errno;
  int count;
  FILE *fp;

  fprintf(stderr, "vncdisplay=%s\n",vncdisplay);
  serverip.s_addr = client_CB.server_ip;
  sprintf (serverport, "%d\0", ntohs(client_CB.server_port));
  sprintf (commandvnc1, "vncconfig -display :%s -connect %s:%s > /dev/null 2>&1; echo -n $?", \
     vncdisplay, (char *)inet_ntoa(serverip), serverport);
  sprintf (commandvnc2, "vncconnect -display :%s %s:%s > /dev/null 2>&1; echo -n $?", \
     vncdisplay, (char *)inet_ntoa(serverip), serverport);
  sprintf (commandvnc3, "vnc4config -display :%s -connect %s:%s > /dev/null 2>&1; echo -n $?", \
     vncdisplay, (char *)inet_ntoa(serverip), serverport);


  /* made sh command */
  fflush (stdout);
  fprintf (stdout, "%s\n", commandvnc1);
  fprintf (stdout, "%s\n", commandvnc2);
  fprintf (stdout, "%s\n", commandvnc3);

  /* execute vncconnect */
  for (count=0; count < TRYCOUNT; count++) {
    fp = popen(commandvnc1, "r");
    if (print_popen(fp) == 0) break;
    fp = popen(commandvnc2, "r");
    if (print_popen(fp) == 0) break;
    fp = popen(commandvnc3, "r");
    if (print_popen(fp) == 0) break;

    randam_sleep ();
  }
  fprintf(stderr,"%d\n",count);
  if (count >= TRYCOUNT) exit (EXIT_FAILURE);

  pclose(fp);

  client_CB.connectstate = STAT_VNC;
}
