#include <windows.h>

/** @brief アプリケーションインスタンスのハンドル*/
HINSTANCE dllHandle = NULL;
/** @brief キーボードイベントのグローバルフック用ハンドル */
HHOOK hookHandle_k = NULL;
/** @brief マウスイベントのグローバルフック用ハンドル */
HHOOK hookHandle_m = NULL;

/** @brief キーボードイベント用のフックプロシージャ */
LRESULT CALLBACK LowLevelKeyboardProc(int nCode, WPARAM wParam, LPARAM lParam)
{
  return TRUE;
}

/** @brief マウスイベント用のフックプロシージャ */
LRESULT CALLBACK LowLevelMouseProc(int nCode, WPARAM wParam, LPARAM lParam)
{
  return TRUE;
}


/// @brief ロック機能実行
///
/// @param	なし
/// @return 0 正常終了 -1 異常終了
int TryHook(void)
{
	BOOL resultUnhook_m = TRUE;

  // キーボードイベントのフック状態判断
  if ( (hookHandle_k != NULL) || (hookHandle_m != NULL) ) {
    return -1;
  }

  // マウスイベントのフック開始
  hookHandle_m = SetWindowsHookEx(
	WH_MOUSE_LL,
	LowLevelMouseProc,
    dllHandle,
    0
  );

  if(hookHandle_m == NULL)
  {
	  return -1;
  }

  // キーボードイベントのフック開始
  hookHandle_k = SetWindowsHookEx(
    WH_KEYBOARD_LL,
    LowLevelKeyboardProc,
    dllHandle,
    0
  );

  if(hookHandle_k == NULL)
  {
	  //マウスイベントのフック用ハンドルを解除する
	  resultUnhook_m = UnhookWindowsHookEx(hookHandle_m);

	  if(resultUnhook_m == FALSE)
	  {
		  hookHandle_m = NULL;
		  hookHandle_k = NULL;
		  return -1;
	  }
	  hookHandle_m = NULL;
	  return -1;
  }

  return 0;

}

/// @brief ロック機能解除
///
/// @param	なし
/// @return 0 正常終了-1 異常終了
int TryUnhook(void)
{
	BOOL resultUnhook_k;
	BOOL resultUnhook_m;

	//キーボードイベントとマウスイベントのフックが行われているか判断
  if ( (hookHandle_k == NULL) && (hookHandle_m == NULL) ) {
    return -1;
  }

	//フックの解除
  resultUnhook_k = UnhookWindowsHookEx(hookHandle_k);
  resultUnhook_m = UnhookWindowsHookEx(hookHandle_m);

  hookHandle_k = NULL;
  hookHandle_m = NULL;

  if( (resultUnhook_k == FALSE)||(resultUnhook_m == FALSE) ){
	  return -1;
  }

  return 0;
}

BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
  dllHandle = hinstDLL;
  return TRUE;
}
